unit Test1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  barcode, StdCtrls, ExtCtrls ,Printers;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    Disp: TButton;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    CB01: TComboBox;
    Label5: TLabel;
    CHB1: TCheckBox;
    Label6: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit3: TEdit;
    CB02: TComboBox;
    GroupBox2: TGroupBox;
    Note: TLabel;
    procedure DispClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CB01Change(Sender: TObject);
  private
    { Private 錾 }
    procedure DrawLine(Position:Integer);
    procedure DrawLine2(Counter,n,Style:Integer);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
  if Tag <> 0  then
    Exit;
  CB01.ItemIndex := 0;
  CB01Change(CB01);
  CB02.ItemIndex := 1;
  Tag := 1;
end;

procedure TForm1.DispClick(Sender: TObject);
var
  i,n      ,
  LineWidth,
  Counter  ,
  Position :Integer;
  BK       :String;
  Rect     :TRect;
begin
  Rect.Top    := 0;
  Rect.Bottom := Image1.Height;
  Rect.Left   := 0;
  Rect.Right  := Image1.Width;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(Rect);

  // R[h^Cv
  case CB01.ItemIndex of
    // JAN(Zk)/EAN
    0:BK := Make_JAN(Edit1.Text);
    // CODE-39
    1:BK := Make_CODE39(Edit1.Text,CHB1.Checked);
    // CODE-128
    2:BK := Make_CODE128(Edit1.Text,Edit2.Text[1]);
    // NW-7(CODABAR)
    3:BK := Make_NW7(Edit1.Text,Edit2.Text[1],Edit3.Text[1],CHB1.Checked);
    // Interleaved 2of5(ITF)
    4:BK := Make_ITF(Edit1.Text,CHB1.Checked);
    // JX^}[o[R[h
    5:BK := Make_CUSTOMER(Edit1.Text + StringOfChar(' ',21 - Length(Edit1.Text)));
  end;

  // {
  n := CB02.ItemIndex + 1;


//Printer.Begindoc;
  if CB01.ItemIndex = 5 then
    begin
      for Counter := 0 to Length(BK)-1 do
        DrawLine2(Counter,n,StrToInt(BK[Counter+1]));
    end
  else
    begin
      Position := 0;
      for Counter:=1 to Length(BK) do
        begin
          LineWidth := ((StrToInt(BK[Counter]) div 2) + 1) * n;
          if (StrToInt(BK[Counter]) mod 2) = 0 then
            // 
            begin
              Position := Position + LineWidth;
            end
          else
            // o[
            begin
              for i:=1 to LineWidth do
                begin
                  DrawLine(Position);
                  Inc(Position);
                end;
            end;
        end;
    end;
//Printer.Enddoc;
end;

procedure TForm1.DrawLine(Position:Integer);
begin
  Image1.Canvas.MoveTo(Position + 30, 0);
  Image1.Canvas.LineTo(Position + 30,99);
//Printer.Canvas.MoveTo(Position + 30,  0);
//Printer.Canvas.LineTo(Position + 30,399);
end;

procedure TForm1.DrawLine2(Counter,n,Style:Integer);
var
  i,j:Integer;
  X1,
  Y1,
  X2,
  Y2:Integer;
begin
  Image1.Canvas.Brush.Color := clBlack;
  for i:=2 downto 0 do
    begin
      j := 1 shl (2-i);
      if (j and Style) = j then
        begin
          X1 := (Counter * n) - n;
          Y1 := ((i+1) * (n * 2)) - (n * 2);
          X2 := (Counter * n);
          Y2 := ((i+1) * (n * 2));
          Image1.Canvas.FillRect(Rect(X1,Y1,X2,Y2));
        end;
      //Printer.Canvas.FillRect(Rect(Counter * n,(i-2) * n,Counter * (n+1),(i-2) * (n+1)));
    end;
end;

procedure TForm1.CB01Change(Sender: TObject);
begin
  case (Sender as TComboBox).ItemIndex of
    // JAN(Zk)/EAN
    // JX^}[o[R[h
    0,5:
      begin
        CHB1.Enabled  := False;
        CHB1.Checked  := False;
        Edit2.Text    := '';
        Edit2.Enabled := False;
        Edit3.Text    := '';
        Edit3.Enabled := False;
      end;
    // CODE-39
    1:begin
        CHB1.Enabled  := True;
        CHB1.Checked  := True;
        Edit2.Text    := '*';
        Edit2.Enabled := False;
        Edit3.Text    := '*';
        Edit3.Enabled := False;
      end;
    // CODE-128
    2:begin
        CHB1.Enabled  := False;
        CHB1.Checked  := False;
        Edit2.Text    := 'A';
        Edit2.Enabled := True;
        Edit3.Text    := '';
        Edit3.Enabled := False;
      end;
    // NW-7(CODABAR)
    3:begin
        CHB1.Enabled  := True;
        CHB1.Checked  := True;
        Edit2.Text    := 'A';
        Edit2.Enabled := True;
        Edit3.Text    := 'A';
        Edit3.Enabled := True;
      end;
    // Interleaved 2of5(ITF)
    4:
      begin
        CHB1.Enabled  := True;
        CHB1.Checked  := True;
        Edit2.Text    := '';
        Edit2.Enabled := False;
        Edit3.Text    := '';
        Edit3.Enabled := False;
      end;
  end;
  case (Sender as TComboBox).ItemIndex of
    // JAN(Zk)/EAN
    0:begin
        Note.Caption := '13/8(l̂)œ͂ĉB' + #$0D#$0A +
                        '12/7̃`FbNfBWbg̓͂\łB';
      end;
    // CODE-39
    1:begin
        Note.Caption := '͔͌CӂłB' + #$0D#$0A +
                        '/At@xbg/7̋Lg܂B';
      end;
    // CODE-128
    2:begin
        Note.Caption := '͔͌CӂłB' + #$0D#$0A +
                        '128̕/Lg܂B' + #$0D#$0A +
                        'LN^́u<>vŊĉBu>v́u>>vAu<v́u<<vœ͂ĉB';
      end;
    // NW-7(CODABAR)
    3:begin
        Note.Caption := '͔͌CӂłB' + #$0D#$0A +
                        '/10̃At@xbgƋLg܂B';
      end;
    // ITF(Interleaved 2of5)
    4:begin
        Note.Caption := '͔͌CӂłB(WV{̏ꍇ6/14/16)' + #$0D#$0A +
                        'l݂̂œ͂ĉB';
      end;
    // JX^}[o[R[h
    5:begin
        Note.Caption := 'X֔ԍ7 + ԍ3(ԍ̏ꍇ)œ͂ĉB';
      end;
  end;
end;

end.


